Return early if the image names don't match
[mirror/dsa-nagios.git] / dsa-nagios-checks / checks / dsa-check-running-kernel
1 #!/bin/bash
2
3 # Check if the running kernel has the same version string as the on-disk
4 # kernel image.
5
6 # Copyright 2008 Peter Palfrader
7 # Copyright 2009 Stephen Gran
8 #
9 # Permission is hereby granted, free of charge, to any person obtaining
10 # a copy of this software and associated documentation files (the
11 # "Software"), to deal in the Software without restriction, including
12 # without limitation the rights to use, copy, modify, merge, publish,
13 # distribute, sublicense, and/or sell copies of the Software, and to
14 # permit persons to whom the Software is furnished to do so, subject to
15 # the following conditions:
16 #
17 # The above copyright notice and this permission notice shall be
18 # included in all copies or substantial portions of the Software.
19 #
20 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
21 # EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
22 # MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
23 # NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
24 # LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
25 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
26 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
27
28 OK=0;
29 WARNING=1;
30 CRITICAL=2;
31 UNKNOWN=3;
32
33 get_offset() {
34         local file needle
35
36         file="$1"
37         needle="$2"
38         perl -e '
39                 undef $/;
40                 $i = index(<>, "'"$needle"'");
41                 if ($i < 0) {
42                         exit 1;
43                 };
44                 print $i,"\n"' < "$file"
45 }
46
47 get_avail() {
48         # This is wrong, but leaves room for when we have to care for machines running
49         # myfirstunix-image-0.1-dsa-arm
50         local prefix=linux
51
52         local kervers=$(uname -r)
53         local kernelversion=$(apt-cache policy ${prefix}-image-${kervers} 2>/dev/null | grep '^  Installed:' | awk '{print $2}')
54
55         local metavers=''
56
57         # DSA uses kernel versions of the form 2.6.29.3-dsa-dl380-oldxeon, where
58         # Debian uses versions of the form 2.6.29-2-amd64
59         if [ "${kervers//dsa}" != "$kervers" ]; then
60                 metavers=$(echo $kervers | sed -r -e 's/^2\.(4|6)\.[0-9]+([\.0-9]+?)-(.*)/2.\1-\3/')
61         else
62                 metavers=$(echo $kervers | sed -r -e 's/^2\.(4|6)\.[0-9]+-[A-Za-z0-9\.]+-(.*)/2.\1-\2/')
63         fi
64
65         # We're just going to give up if we can't find a matching metapackage
66         # I tried being strict once, and it just caused a lot of headaches.  We'll see how
67         # being lax does for us
68
69         local output=$(apt-cache policy ${prefix}-image-${metavers} 2>/dev/null)
70         local metaavailvers=$(echo "$output" | grep '^  Candidate:' | awk '{print $2}')
71         local metainstavers=$(echo "$output" | grep '^  Installed:' | awk '{print $2}')
72
73         if [ -z "$metaavailvers" ] || [ "$metaavailvers" = '(none)' ]; then
74                 return 2
75         fi
76         if [ -z "$metainstavers" ] || [ "$metainstavers" = '(none)' ]; then
77                 return 2
78         fi
79
80         local last=0
81         for vers in $(apt-cache --no-all-versions depends ${prefix}-image-${metavers} | grep Depends | awk '{print $2}' | sort -u); do
82                 if dpkg --compare-versions $vers gt $last; then
83                         last=$vers
84                 fi
85         done
86         local imagename=$last
87
88         if [ -z "$imagename" ] || [ "$imagename" = 0 ]; then
89                 return 2
90         fi
91
92         if [ "$imagename" != "${prefix}-image-${kervers}" ]; then
93                 echo "$imagename" != "${prefix}-image-${kervers}"
94                 return 1
95         fi
96
97         local availvrs=$(apt-cache policy ${imagename} 2>/dev/null | grep '^  Candidate' | awk '{print $2}')
98
99         if [ "$availvrs" = "$kernelversion" ]; then
100                 return 0
101         fi
102
103         echo "$kernelversion != $availvrs"
104         return 1
105 }
106
107
108 get_image() {
109         local image GZHDR1 GZHDR2 off
110
111         image="$1"
112
113         GZHDR1="\x1f\x8b\x08\x00"
114         GZHDR2="\x1f\x8b\x08\x08"
115
116         off=`get_offset "$image" $GZHDR1`
117         [ "$?" != "0" ] && off="-1"
118         if [ "$off" -eq "-1" ]; then
119                 off=`get_offset "$image" $GZHDR2`
120                 [ "$?" != "0" ] && off="-1"
121         fi
122         if [ "$off" -eq "0" ]; then
123                 zcat < "$image"
124                 return
125         elif [ "$off" -ne "-1" ]; then
126                 (dd ibs="$off" skip=1 count=0 && dd bs=512k) < "$image"  2>/dev/null | zcat 2>/dev/null
127                 return
128         fi
129
130         echo "ERROR: Unable to extract kernel image." 2>&1
131         exit 1
132 }
133
134 searched=""
135 for on_disk in \
136         "/boot/vmlinuz-`uname -r`"\
137         "/boot/vmlinux-`uname -r`"; do
138
139         if [ -e "$on_disk" ]; then
140                 on_disk_version="`get_image "$on_disk" | strings | grep 'Linux version' | head -n1`"
141                 [ -z "$on_disk_version" ] || break
142                 on_disk_version="`cat "$on_disk" | strings | grep 'Linux version' | head -n1`"
143                 [ -z "$on_disk_version" ] || break
144
145                 echo "UNKNOWN: Failed to get a version string from image $on_disk"
146                 exit $UNKNOWN
147         fi
148         searched="$searched $on_disk"
149 done
150
151 if ! [ -e "$on_disk" ]; then
152         echo "WARNING: Did not find a kernel image (checked$searched) - I have no idea which kernel I am running"
153         exit $WARNING
154 fi
155
156
157 running_version="`cat /proc/version`"
158 if [ -z "$running_version" ] ; then
159         echo "UNKNOWN: Failed to get a version string from running system"
160         exit $UNKNOWN
161 fi
162
163 if [ "$running_version" != "$on_disk_version" ]; then
164         echo "WARNING: Running kernel does not match on-disk kernel image: [$running_version != $on_disk_version]"
165         exit $WARNING
166 fi
167
168 ret="$(get_avail)"
169 if [ $? = 1 ]; then
170         echo "WARNING: Kernel needs upgrade [$ret]"
171         exit $WARNING
172 fi
173
174 echo "OK: Running kernel matches on disk image: [$running_version]"
175 exit $OK